# Deploying Services requiered by Journal using image_builder

## Nginx Proxy manager
Requirements :
    - Nginx WebUI : https://github.com/0xJacky/nginx-ui
    - Configs and Websites Stored Webserver for easy redeployment and changes

### Making Installation script :
The easiest way to do this is to manually install and configure things how you want them. Then figure out how to automate that after which you can provide set in place updatable images.

1. Making our Temporary Debian CT, adding the data directory and starting it : `pct create 201 adastor:vztmpl/debian-12-standard_12.2-1_amd64.tar.zst --rootfs local-btrfs:8 --cores 2 --memory 1024 --swap 512 --net0 name=eth0,bridge=vmbr0,ip=dhcp --hostname debian-nginx-temp && pct set 201 -mp0 local-btrfs:8,mp=/data,size=8G && pct start 201`
2. Entering our container : `pct enter 201`
3. Completing a Manual Installation of the basics :
```
apt update
apt upgrade -y
apt install nginx-full curl -y
systemctl enable --now nginx
bash <(curl -L -s https://raw.githubusercontent.com/0xJacky/nginx-ui/master/install.sh) install
systemctl enable --now nginx-ui
```
4. Making it a bash script and implementing our config files aswell as website files :
See debian-nginx.conf
5. Building the Container Image : `./image_builder.sh --param-file debian-nginx.conf`
6. Move to your CT Template dir of choice :`mv ./vzdump-lxc-202-2024_06_29-10_52_05.tar.gz /mnt/pve/adastor/template/cache/debian-nginx-2024-06-29.tar.gz`
7. Enjoy our success and Deploy where needed

## Vaultwarden Password manager

Requirements :
    - Vaultwarden + Web : https://github.com/dani-garcia/vaultwarden

### Making Installation script :
1. Making our Temporary Alpine CT, adding the data directory and starting it : `pct create 201 adastor:vztmpl/alpine-3.19-default_plus_bash_20240207_amd64.tar.xz --rootfs local-btrfs:8 --cores 2 --memory 1024 --swap 512 --net0 name=eth0,bridge=vmbr0,ip=dhcp --hostname alpine-vaultwarden-temp && pct set 202,size=8G && pct start 202`
2. Entering our container : `pct enter 201`
3. Completing a Manual Installation of the basics :
```
apk update
apk add bash openssh vaultwarden
apk add vaultwarden-web-vault
rc-service --list
rc-update add vaultwarden
rc-update add sshd
rc-service sshd start
nano /etc/conf.d/vaultwarden
rc-update add vaultwarden
rc-service vaultwarden start
```
4. Making it a bash script and implementing our config files aswell as website files :
See debian-nginx.conf
5. Building the Container Image : `./image_builder.sh --param-file debian-nginx.conf`
6. Move to your CT Template dir of choice :`mv ./vzdump-lxc-202-2024_06_29-10_52_05.tar.gz /mnt/pve/adastor/template/cache/debian-nginx-2024-06-29.tar.gz`
7. Enjoy our success and Deploy where needed

# Why I dont list every service here ?
As seen it is pretty easy to make Container Templates using basic Bash scripting and usage of the image_builder.
For the rest of the Services simply have a look at the [remaining config files in this directory](https://adastra7.net/git/crt/m169/src/branch/master/image-builder-512mb)

# Where is Mailcow ?
Mailcow has been excluded as it uses docker, I've however made a container template that installs the docker engine so use that (configuring email is a pain and I would recommnd you make manual images)